/*
 *
 *  ߥˡ˥塼꡼
 *
 *  Copyright 1993-1999 Matsushita Soft-Research, INC. A.Takuma
 *
 *  System      : Mini News Reader
 *  Sub system  : Compatible routine
 *  File        : compat.c
 *  Version     : 1.22
 *  First Edit  : 1993-12/10
 *  Last  Edit  : 1999-12/15
 *  Author      : MSRS3  
 *
 */

#include	<stdio.h>
#if	!defined(LUNA) && !defined(SUNOS_40) && !defined(SUNOS_3X) && !defined(SVR3)
#include	<stdlib.h>
#endif	/* (!LUNA && !SUNOS_40 && !SUNOS_3X && !SVR3) */
#include	<sys/types.h>
#include	<ctype.h>
#ifdef	__STDC__
#include	<stdarg.h>
#else	/* !__STDC__ */
#include	<varargs.h>
#endif	/* !__STDC__ */
#ifdef	MSC
#include	<malloc.h>
#endif	/* MSC */
#ifdef	__TURBOC__
#include	<alloc.h>
#include	<dos.h>
#endif	/* __TURBOC__ */

#if	defined(MSDOS) || defined(OS2)
#define	SLASH_CHAR	'\\'
#else	/* !(MSDOS || OS2) */
#define	SLASH_CHAR	'/'
#endif	/* !(MSDOS || OS2) */

#ifndef	BUFF_SIZE
#define	BUFF_SIZE	1024
#endif	/* !BUFF_SIZE */
#ifndef	SMALL_BUFF
#define	SMALL_BUFF	256
#endif	/* !SMALL_BUFF */

#if	defined(MNEWS) || defined(KCHK) || defined(KGREP) ||  defined(MANEKIN) || defined(NEWSREPORT)
#define	USE_PIPE
#endif	/* !(MNEWS || KCHK || KGREP || MANEKIN || NEWSREPORT) */

#if	defined(LUNA) || defined(SUNOS_41) || defined(SUNOS_40) || defined(SUNOS_3X)
#define	DONT_HAVE_MEMMOVE
#endif	/* (LUNA || SUNOS_41 || SUNOS_40 || SUNOS_3X) */

/*
 * ʸ(ʸʸ̤ʤ)
 * strncasecmp ʤޥ
 */

#if	defined(LUNA) || defined(SVR3) || defined(SVR4) || defined(SUNOS_41) || defined(SUNOS_40) || defined(SUNOS_3X) || (defined(MSDOS) && !defined(__GO32__) && !defined(X68K)) || defined(OS2)
#ifndef	STRCASECMP
#define	Toupper(c)	((unsigned char) (islower(c) ? toupper(c) : (c)))

#ifdef	__STDC__
int	strcasecmp(char *s1, char *s2)
#else	/* !__STDC__ */
int	strcasecmp(s1, s2)
	char	*s1;
	char	*s2;
#endif	/* !__STDC__ */
{
  for (; ((unsigned char)Toupper(*s1) == (unsigned char)Toupper(*s2));
       s1++ , s2++) {
    if ((*s1 == '\0') || (*s2 == '\0')) {
      break;
    }
  }
  return(Toupper(*s1) - Toupper(*s2));
}

#ifdef	__STDC__
int	strncasecmp(char *s1, char *s2, int n)
#else	/* !__STDC__ */
int	strncasecmp(s1, s2, n)
	char	*s1;
	char	*s2;
	int	n;
#endif	/* !__STDC__ */
{
  for (; (n > 1 &&
	   ((unsigned char)Toupper(*s1) == (unsigned char)Toupper(*s2)));
       s1++ , s2++ , n--) {
    if ((*s1 == '\0') || (*s2 == '\0')) {
      break;
    }
  }
  return(Toupper(*s1) - Toupper(*s2));
}
#endif	/* !STRCASECMP */
#endif	/* (LUNA || SVR3 || SVR4 || SUNOS_41 || SUNOS_40 || SUNOS_3X || (MSDOS && !__GO32__ && !X68K) || OS2) */

#ifdef	PRINTF_ZERO
#ifdef	__STDC__
int	printf2(char *fmt, ...)
#else	/* !__STDC__ */
int	printf2(fmt, va_alist)
     char	*fmt;
#endif	/* !__STDC__ */
{
  va_list	ap;
  char		buff[BUFF_SIZE];

#ifdef	__STDC__
  va_start(ap, fmt);
#else	/* !__STDC__ */
  va_start(ap);
#endif	/* !__STDC__ */
  vsprintf(buff, fmt, ap);
  printf("%s", buff);
  va_end(ap);
  return(strlen(buff));
}

#ifdef	__STDC__
int	fprintf2(FILE *fp, char *fmt, ...)
#else	/* !__STDC__ */
int	fprintf2(fp, fmt, va_alist)
     FILE	*fp;
     char	*fmt;
#endif	/* !__STDC__ */
{
  va_list	ap;
  char		buff[BUFF_SIZE];

#ifdef	__STDC__
  va_start(ap, fmt);
#else	/* !__STDC__ */
  va_start(ap);
#endif	/* !__STDC__ */
  vsprintf(buff, fmt, ap);
  fprintf(fp, "%s", buff);
  va_end(ap);
  return(strlen(buff));
}
#endif	/* PRINTF_ZERO */

#ifdef	SVR3
#ifndef	RENAME
#include	<errno.h>
#include	<sys/types.h>
#include	<sys/stat.h>

#ifdef	__STDC__
int	rename(char *src, char *dist)
#else	/* !__STDC__ */
int	rename(src, dist)
     char	*src;
     char	*dist;
#endif	/* !__STDC__ */
{
  struct stat	s1,s2;
  extern int	errno;

  if (stat(src, &s1) < 0) {
    return(-1);
  }

  /*
   * src ϥǥ쥯ȥ꤫?
   */

  if ((s1.st_mode & S_IFMT) == S_IFDIR) {
    errno = ENOTDIR;
    return(-1);
  }

  if (stat(dist, &s2) >= 0) {

    /*
     * dist ϥǥ쥯ȥ꤫?
     */

    if ((s2.st_mode & S_IFMT) == S_IFDIR) {
      errno = EISDIR;
      return(-1);
    }
    if (unlink(dist) < 0) {
      return(-1);
    }
  }
  if (link(src, dist) < 0) {
    return(-1);
  }
  if (unlink(src) < 0) {
    return(-1);
  }
  return(0);
}
#endif	/* !RENAME */

/*
 * ХååץեΥѥ̾
 * (ե̾14ʸ¤ޥ)
 */

#ifdef	__STDC__
void	create_backup_SVR3(char *bak, char *org)
#else	/* !__STDC__ */
void	create_backup_SVR3(bak, org)
     char	*bak;
     char	*org;
#endif	/* !__STDC__ */
{
  register int	i, j;

  sprintf(bak, "%s~", org);
  j = strlen(org);
  if (j-- < 14) {
    return;
  }
  for (i = j; i >= 0 && org[i] != '/'; i--) {
  }
  if ((j - i) < 14) {
    return;
  }
  strcpy(&bak[i + 14], "~");
}
#endif	/* SVR3 */

#ifdef	DONT_HAVE_MEMMOVE
/*
 * ư
 *
 *   ǽ:ư(ԡ)롣
 *   :char		*ptr1;	ư
 *	  char		*ptr2;	ư
 *	  size_t	length;	ư
 * :char*		ΰư
 *   :memcpy Ȥ memmove ϥХåפǤ롣
 */

#ifdef	notdef
#ifdef	__STDC__
char	*memmove(char *ptr1, char *ptr2, int length)
#else	/* !__STDC__ */
char	*memmove(ptr1, ptr2, length)
     char	*ptr1, *ptr2;
     int	length;
#endif	/* !__STDC__ */
{
  char   *bf;
  int    i, fg;

  fg = 0;
  if ((unsigned long)ptr1 < (unsigned long)ptr2) {
    if (((unsigned long)ptr1 + (unsigned long)length)
	> (unsigned long)ptr2) {
      fg = 1;
    }
  } else if ((unsigned long)ptr2 < (unsigned long)ptr1) {
    if (((unsigned long)ptr2 + (unsigned long)length)
	> (unsigned long)ptr1) {
      fg = 2;
    }
  } else {
    return((int) ptr1);
  }

  switch (fg) {
  case 0:	/* area is'nt overrap */
    memcpy(ptr1, ptr2, length);
    break;
  case 1:	/* dist-area is first */
  case 2:	/* src-area is first */
    bf = (char*)malloc(length);
    if (bf == (char*)NULL) {
      fprintf(stderr, "Can't allocate memory for memmove.\n");
      return(-1);
    }
    memcpy(bf, ptr2, length);
    memcpy(ptr1, bf, length);
    free(bf);
    break;
  }
  return(ptr1);
}
#else	/* !notdef */
#ifdef	__STDC__
char	*memmove(char *ptr1, char *ptr2, size_t length)
#else	/* !__STDC__ */
char	*memmove(ptr1, ptr2, length)
     char	*ptr1;
     char	*ptr2;
     size_t	length;
#endif	/* !__STDC__ */
{
  char	*ptr3;
  int	overlap = 0;

  ptr3 = ptr1;
  if ((unsigned long)ptr1 < (unsigned long)ptr2) {
    if (((unsigned long)ptr1 + (unsigned long)length) > (unsigned long)ptr2) {
      overlap = 1;
    }
  } else if ((unsigned long)ptr2 < (unsigned long)ptr1) {
    if (((unsigned long)ptr2 + (unsigned long)length) > (unsigned long)ptr1) {
      overlap = 2;
    }
  } else {
    return(ptr1);
  }

  switch (overlap) {
  case 0:	/* Хåפʤ	*/
    memcpy(ptr1, ptr2, length);
    break;
  case 1:	/* ư < ư */
    while (length--) {
      *ptr1++ = *ptr2++;
    }
    break;
  case 2:	/* ư > ư */
    ptr1 += length;
    ptr2 += length;
    while (length--) {
      *--ptr1 = *--ptr2;
    }
    break;
  }
  return(ptr3);
}
#endif	/* !notdef */
#endif	/* DONT_HAVE_MEMMOVE */

#ifdef	DONT_HAVE_MEMSET
/*
 * Ŷ
 *
 *   ǽ:ǡŶ(ե)롣
 *   :char		*ptr1;	Ŷ
 *	  int		data;	ǡ
 *	  size_t	length;	Ŷ
 * :char* 	Ŷ֤
 */

#ifdef	__STDC__
char	*memset(char *ptr1, int data, size_t length)
#else	/* !__STDC__ */
char	*memset(ptr1, data, length)
     char	*ptr1;
     int	data;
     size_t	length;
#endif	/* !__STDC__ */
{
  char	*ptr2;

  ptr2 = ptr1;
  while (length--) {
    *ptr1++ = data;
  }
  return(ptr2);
}
#endif	/* DONT_HAVE_MEMSET */

#ifdef	MSDOS
/*
 * ХååץեΥѥ̾
 * (ե̾8ʸ¤ޥ)
 */

#ifdef	__STDC__
void  create_backup_DOS(char *bak, char *org)
#else	/* !__STDC__ */
void  create_backup_DOS(bak, org)
     char	*bak;
     char	*org;
#endif	/* !__STDC__ */
{
  register int    i, j;

  sprintf(bak, "%s~", org);
  j = strlen(org);
  if (j-- < 8) {
    return;
  }
  for (i = j; i >= 0 && org[i] != '/' && org[i] != '\\'; i--) {
  }
  if ((j - i) < 8) {
    return;
  }
  strcpy(&bak[i + 8], "~");
}

/*
 * getpid()  getpid ؿΥɥ쥹 % 1000 Ǹⲽ
 */

#ifdef	__STDC__
int	getpid(void)
#else	/* !__STDC__ */
int	getpid()
#endif	/* !__STDC__ */
{
  return(((int)getpid) % 1000);
}

/*
 * sleep() ñ롼פǸⲽ
 */

#ifndef	X68K
#ifndef	__TURBOC__
#ifdef	__STDC__
int	sleep(int second)
#else	/* !__STDC__ */
int	sleep(second)
     int	second;
#endif	/* !__STDC__ */
{
  register int	i, j, n;

  n = 0;
  for (i = 0; i < second; i++) {
    for (j = 0; j < 0x7FFF; j++) {
      n += j;
    }
  }
  return(n);
}
#endif	/* __TURBOC__ */

#ifndef	__GO32__
#ifdef	USE_PIPE
struct pipe_file {
  FILE			*pipe_fp;
  char			pipe_cmd[SMALL_BUFF];
  char			pipe_file[SMALL_BUFF];
  struct pipe_file	*next_ptr;
};

extern char		tmp_dir[];

static struct pipe_file	*top_pipe_ptr = (struct pipe_file*)NULL;
static int		pipe_number = 0;

#ifdef	__STDC__
FILE	*popen(char *cmd, char *mode)
#else	/* !__STDC__ */
FILE	*popen(cmd, mode)
     char	*cmd;
     char	*mode;
#endif	/* !__STDC__ */
{
  FILE			*fp;
  struct pipe_file	*pipe_ptr;
  char			buff[SMALL_BUFF];
  char			pipe_file[SMALL_BUFF];

  fp = (FILE*)NULL;
  sprintf(pipe_file, "%s%cpipe_%03d.%d", tmp_dir, SLASH_CHAR,
	 pipe_number << 16, (int)getpid());
  if (*mode == 'r') {
    sprintf(buff, "%s > %s", cmd, pipe_file);
    cmd = "";
    if (!system(buff)) {
      fp = fopen(pipe_file, "r");
    }
  } else if (*mode == 'w') {
    fp = fopen(pipe_file, "w");
  }
  if (fp != (FILE*)NULL) {
    pipe_ptr = (struct pipe_file*)malloc(sizeof(struct pipe_file));
    if (pipe_ptr != (struct pipe_file*)NULL) {
      pipe_ptr->next_ptr = top_pipe_ptr;
      top_pipe_ptr = pipe_ptr;
      pipe_ptr->pipe_fp = fp;
      strcpy(pipe_ptr->pipe_cmd, cmd);
      strcpy(pipe_ptr->pipe_file, pipe_file);
      pipe_number++;
    }
  }
  return((FILE*)fp);
}

#ifdef	__STDC__
int	pclose(FILE *fp)
#else	/* !__STDC__ */
int	pclose(fp)
     FILE	*fp;
#endif	/* !__STDC__ */
{
  struct pipe_file	*pipe_ptr1, *pipe_ptr2;
  char			buff[SMALL_BUFF];
  int			status;

  pipe_ptr1 = top_pipe_ptr;
  pipe_ptr2 = (struct pipe_file*)NULL;
  while (pipe_ptr1 != (struct pipe_file*)NULL) {
    if (pipe_ptr1->pipe_fp == fp) {
      fclose(fp);
      status = 0;
      if (pipe_ptr1->pipe_cmd[0]) {
	sprintf(buff, "%s < %s", pipe_ptr1->pipe_cmd, pipe_ptr1->pipe_file);
	status = system(buff);
      }
      unlink(pipe_ptr1->pipe_file);
      if (pipe_ptr2 == (struct pipe_file*)NULL) {
	top_pipe_ptr = pipe_ptr1->next_ptr;
      } else {
	pipe_ptr2->next_ptr = pipe_ptr1->next_ptr;
      }
      free(pipe_ptr1);
      pipe_number--;
      return(status);
    }
    pipe_ptr2 = pipe_ptr1;
    pipe_ptr1 = pipe_ptr1->next_ptr;
  }
  return(1);
}
#endif	/* USE_PIPE */
#endif	/* !__GO32__ */
#endif	/* !X68K */
#endif	/* MSDOS */

#ifdef	MSDOS
#if	!(defined(X68K) || defined(__GO32__) || defined(__WIN32__))
#ifdef	__STDC__
void	*large_malloc(unsigned long alloc_size)
#else	/* !__STDC__ */
void	*large_malloc(alloc_size)
  unsigned long	alloc_size;
#endif	/* !__STDC__ */
{
  if (alloc_size >= 65536L) {
    return((void*)NULL);
  }
#ifdef	__TURBOC__
#ifdef	__WIN32__
  return(malloc((size_t)alloc_size));
#else	/* !__WIN32__ */
  return(farmalloc((unsigned long)alloc_size));
#endif	/* !__WIN32__ */
#else	/* !__TURBOC__ */
  return(malloc((size_t)alloc_size));
#endif	/* !__TURBOC__ */
}

#ifdef	__STDC__
void	*large_realloc(char *large_ptr, unsigned long alloc_size)
#else	/* !__STDC__ */
void	*large_realloc(large_ptr, alloc_size)
  char		*large_ptr;
  unsigned long	alloc_size;
#endif	/* !__STDC__ */
{
  if (alloc_size >= 65536L) {
    return((void*)NULL);
  }
#ifdef	__TURBOC__
#ifdef	__WIN32__
  return(realloc(large_ptr, (size_t)alloc_size));
#else	/* !__WIN32__ */
  return(farrealloc(large_ptr, (unsigned long)alloc_size));
#endif	/* !__WIN32__ */
#else	/* !__TURBOC__ */
  return(realloc(large_ptr, (size_t)alloc_size));
#endif	/* !__TURBOC__ */
}

#ifdef	__STDC__
void	large_free(char *large_ptr)
#else	/* !__STDC__ */
void	large_free(large_ptr)
  char	*large_ptr;
#endif	/* !__STDC__ */
{
#ifdef	__TURBOC__
#ifdef	__WIN32__
  free(large_ptr);
#else	/* !__WIN32__ */
  farfree(large_ptr);
#endif	/* !__WIN32__ */
#else	/* !__TURBOC__ */
  free(large_ptr);
#endif	/* !__TURBOC__ */
}
#endif	/* !(X68K || __GO32__ || __WIN32__) */
#endif	/* MSDOS */

#ifdef	__GO32__
/*
 * DJGPPgetch()ATǤưʤΤDOSȤ
 */
#include	<dos.h>
#define	DOS_coninput	0x07		/* direct console input		*/
#ifdef	__STDC__
int	getch(void)
#else	/* !__STDC__ */
int	getch()
#endif	/* !__STDC__ */
{
  union	REGS	regs;
  int		key;

  regs.h.ah = DOS_coninput;
  intdos(&regs, &regs);
  key = (int)regs.h.al;
  return(key);
}
#endif	/* __GO32__ */

#if	defined(MSDOS) || defined(OS2)
/*
 * ѥ̾
 */

#ifdef	__STDC__
int	strnamecmp(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
int	strnamecmp(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  int	c;

  c = 0;
  while (*ptr1 && *ptr2) {
#ifdef	X68K
    if (ismbblead(*ptr1)) {			/* 1Х	*/
#else	/* !X68K */
    if (((*((unsigned char*)ptr1) >= 0x81) &&
	 (*((unsigned char*)ptr1) <= 0x9f)) ||
	((*((unsigned char*)ptr1) >= 0xe0) &&
	 (*((unsigned char*)ptr1) <= 0xfc))) {	/* 1Х	*/
#endif	/* !X68K */
      c = *((unsigned char*)ptr1++) - *((unsigned char*)ptr2++);
      if (!c) {
	c = *((unsigned char*)ptr1++) - *((unsigned char*)ptr2++);
      }
    } else if ((*ptr1 == '/') || (*ptr1 == '\\')) {
      if ((*ptr2 == '/') || (*ptr2 == '\\')) {
	ptr1++;
	ptr2++;
      } else {
	c = *((unsigned char*)ptr1++) - *((unsigned char*)ptr2++);
      }
    } else {
      c = (unsigned char)Toupper(*ptr1) - (unsigned char)Toupper(*ptr2);
      ptr1++;
      ptr2++;
    }
    if (c) {
      break;
    }
  } if ((c == 0) && (!*ptr1 || !*ptr2)) {
    c = (unsigned char)Toupper(*ptr1) - (unsigned char)Toupper(*ptr2);
  }
  return(c);
}

/*
 * ѥ̾(ʸ)
 */

#ifdef	__STDC__
int	strnnamecmp(char *ptr1, char *ptr2, int length)
#else	/* !__STDC__ */
int	strnnamecmp(ptr1, ptr2, length)
     char	*ptr1;
     char	*ptr2;
     int	length;
#endif	/* !__STDC__ */
{
  int	c;

  c = 0;
  while (*ptr1 && (length-- > 0)) {
#ifdef	X68K
    if (ismbblead(*ptr1)) {			/* 1Х	*/
#else	/* !X68K */
    if (((*((unsigned char*)ptr1) >= 0x81) &&
	 (*((unsigned char*)ptr1) <= 0x9f)) ||
	((*((unsigned char*)ptr1) >= 0xe0) &&
	 (*((unsigned char*)ptr1) <= 0xfc))) {	/* 1Х	*/
#endif	/* !X68K */
      c = *((unsigned char*)ptr1++) - *((unsigned char*)ptr2++);
      if (!c) {
	c = *((unsigned char*)ptr1++) - *((unsigned char*)ptr2++);
      }
    } else if ((*ptr1 == '/') || (*ptr1 == '\\')) {
      if ((*ptr2 == '/') || (*ptr2 == '\\')) {
	ptr1++;
	ptr2++;
      } else {
	c = *((unsigned char*)ptr1) - *((unsigned char*)ptr2);
      }
    } else {
      c = (unsigned char)Toupper(*ptr1) - (unsigned char)Toupper(*ptr2);
      ptr1++;
      ptr2++;
    }
    if (c) {
      break;
    }
  }
  return(c);
}
#endif	/* (MSDOS || OS2) */

/*
 * ѥڸ
 */

#ifdef	__STDC__
char	*separator(char *ptr1)
#else	/* !__STDC__ */
char	*separator(ptr1)
     char	*ptr1;
#endif	/* !__STDC__ */
{
#if	defined(MSDOS) || defined(OS2)
  char	*ptr2 = (char*)NULL;

  while (*ptr1) {
#ifdef	X68K
    if (ismbblead(*ptr1)) {			/* 1Х	*/
#else	/* !X68K */
    if (((*((unsigned char*)ptr1) >= 0x81) &&
	 (*((unsigned char*)ptr1) <= 0x9f)) ||
	((*((unsigned char*)ptr1) >= 0xe0) &&
	 (*((unsigned char*)ptr1) <= 0xfc))) {	/* 1Х	*/
#endif	/* !X68K */
      ptr1 += 2;
    } else if ((*ptr1 == '/') || (*ptr1 == '\\') || (*ptr1 == ':')) {
      ptr2 = ptr1++;
    } else {
      ptr1++;
    }
  }
  return(ptr2);
#else	/* !(MSDOS || OS2) */
  return((char*)strrchr(ptr1, (char)'/'));
#endif	/* !(MSDOS || OS2) */
}
